unit Hamlog50;

interface

uses
	 Windows, Sysutils;

const
	IsQSOdata = 16;
	IsMASdata = 32;
	DbsCallDX =	IsQSOdata;
	DbsCodeDX =  (1 + IsQSOdata);
	MasCodeDX =  (2 + IsMASdata);
	MasFCodeDX = (3 + IsMASdata);
	MasFHedEDX = (4 + IsMASdata);
	DbsGlidDX =  (5 + IsQSOdata);	//	fk
	DbsNoNDX  =	 (8 + IsQSOdata);
	MasNoNDX  =  (9 + IsMASdata);
	is_DXQSO = 8;
	isCQ_CALLED = 16;   //	ǂCQŌMn܂
	Chk1_Checked = 32;
	Chk2_Checked = 64;
	Top2Flag_57 = 57;		//	擪Flag1܂ TQsoBuff
	Top2Flag_43 = 43;		//	擪Flag1 TLogData
	DX_SKIP = 256;		{ 501B ȏXLbv }
	DUP__CHECK = 512;	{ Yf[^͕邩H }
	CallIndexLen = 8;	//	R[TĈW܂ŃCfbNX

	SUCCESS	 = 0;		{	  	}
	SUCCESS_ = 1;		{	EύXȂ	}
	NODBF	= 2;		{	DBFHłȂ	}
	NONDX	= 3;		{	NDXłȂ	}
	NOPEN	= 5;		{	I[vłȂEĂȂ	}
	NOMEM	= 6;		{	[mۂłȂ	}
	R_IOERR	= 7;		{	CfbNX[hG[	}
	W_IOERR	= 8;		{	CfbNXCgG[	}
	DBFEOF	= 10;		{	DBFH̏I	}
	DBFBOF	= 11;		{	DBFĤ͂	}
	NDXEOF	= 12;		{	NDX̏I	}
	NDXBOF	= 13;		{	NDX̂͂	}
	NOSYC	= 15;		{	DBFH  NDX s	}
	NOSET	= 16;		{	L[|C^ݒ	}
	NOKEY	= 17;		{	L[	}
	MAYBE	= 18;		{	L[v	}
	RD_ERR	= 21;		{	fBXN[hG[	}
	WR_ERR	= 22;		{	fBXNCgG[	}
	MKIDXERR = 23;		{	CfbNX\zG[	}
	NO_DBR	= 24;		{	f[^s	}
	NOTEMP	= 25;		{	ƃt@CȂ	}
	NO_KEY	= 26;		{	L[\s	}
	NO_STK	= 27;		{	X^bNI[o[t[	}
	NO_SORT	= 29;		{	sȃ\[gA͏d	}

	LDBF_NOPEN = 40;	{	HAMLOG.HDBI[vłȂ	}
	MDBF_NOPEN = 42;	{	HAMLOG.MSTI[vłȂ	}
	KAKUNIN_NO = $0010;	//	f[^o^mFbZ[W
	FIELD_COUNT = 14;	//	͍ڂ͂PS
	U_Option = 0;	{ USER.TXT }
	V_Option = 1;
	W_Option = 2;

	X19MHZ = 0;
	X35MHZ = 1;		{	3.5MHz`3.8MHz	}
	X7_MHZ = 2;
	X10MHZ = 3;
	X14MHZ = 4;
	X18MHZ = 5;
	X21MHZ = 6;
	X24MHZ = 7;
	X28MHZ = 8;		{	28MHz ` 29MHz	}
	X50MHZ = 9;
	X144MHZ = 10;
	X430MHZ = 11;
	X120MHZ = 12;
	X240MHZ = 13;
	X560MHZ = 14;
	MAXBAND = 15;
	SATELLITE = 16;
	TurboHAMLOG: PChar = 'Turbo HAMLOG/Win';
	WKD_STAT = 45;		{ HAMLOG.MST39޲Ėڂ4޲ 1+6+34+4}
//	WM_COPYDATA ----------------
	THW_ENTER = $10000;	//	f[^MAENTERL[̂Ɠ
	THW_FOCUS = $20000;	//	f[^MAҏW{bNXɃtH[JX
	THW_SAVEBOX_ON = $40000;	//	f[^ۑ
	THW_SAVEBOX_OFF = $80000;	//	f[^ۑ
	THW_APPLIHWND =  $100000;	//	CEChẼnh

type
	TIDXh = Packed record
		np_: Pointer;
		fp_: Integer;
		w_flag: SmallInt;
		fname: array [0..MAX_PATH-1] of Char;
	end;

	TDBFh = Packed record
		lupdt: array [0..3] of Byte;
		rcount: LongInt;
		hsize, rsize: SmallInt;
		recnm: LongInt;
		fhandle: Integer;
		update: SmallInt;
		fname: array [0..MAX_PATH-1] of Char;
	end;
//---------------------- `f[^ ------------------------
	TDBRh = Packed record
		lupdt: array [0..3] of Byte;
		rcount: LongInt;
		fhandle: Integer;
		update: SmallInt;
	end;

	TRBuff = Packed record
		qBuff: array [0..139] of Char;
		rm_1, rm_2: PChar;
		rsize: Byte;
	end;

	TOldData = Packed record
		cBuff: array [0..52] of Char;
		ofs: LongInt;
		dummy: Char;
	end;

	TOldBuff = Packed record
		Calls: array [0..7] of Char;
		Potbl: array [0..3] of Char;
		Date: array [0..8] of Char;
		Time: array [0..6] of Char;
		Hiss: array [0..3] of Char;
		Myrs: array [0..3] of Char;
		Freq: array [0..7] of Char;
		Mode: array [0..3] of Char;
		Code: array [0..6] of Char;
		Glid: array [0..6] of Char;
		Qsl:  array [0..3] of Char;		{ Qsl, Send, Rcv }
		_Name: array [0..12] of Char;
		Qth: array [0..28] of Char;
		Rmk1: array [0..54] of Char;
		Rmk2: array [0..54] of Char;
	end;

	TOldLog = Packed record
		Qso: TOldBuff;		//	prnobt@
		logdt: TOldData;
		ldbf: TDBFh;
		ldbR: TDBRh;
		rbf: TRBuff;
	end;
//-------------------- `f[^E܂ --------------------

	TLogStruct = Packed record
		fld: PChar;			//	̨ޖ
		len: Integer;			//	̨ޒ
	end;

	TLogData = Packed record
		calls: array [0..19] of Char;	//	ٻ
		date: array [0..3] of Char;		//	t
		time: array [0..1] of Char;		//	
		code: array [0..5] of Char;		//	JCC
		glid: array [0..5] of Char;		//	د۹
		qsl: array [0..2] of Char; 		//	QSL Via, Send, Rcv
		flag1: Word;
		hiss: array [0..755] of Char;	//	"HIS","MY","FREQ","MODE","NAME","QTH","RMK1","RMK2"
		myrs, freq, mode, _name, qth, rmk1, rmk2: PChar;
		dummy: Char;
	end;

	pTQsoBuff = ^TQsoBuff;
	TQsoBuff = Packed record
		Calls: array [0..20] of Char;
		Date: array [0..8] of Char;
		Time: array [0..6] of Char;
		Code: array [0..6] of Char;
		Glid: array [0..6] of Char;
		Qsl:  array [0..3] of Char;		//	Qsl, Send, Rcv
		Flag1: Word;
		Hiss: array [0..763] of Char;
		Myrs, Freq, Mode, _Name, Qth, Rmk1, Rmk2: PChar;
		HissLen, MyrsLen, FreqLen, ModeLen, NameLen, QthLen, Rmk1Len, Rmk2Len: Byte;
	end;

	pTQsoBuff3 = ^TQsoBuff3;
	TQsoBuff3 = Packed record
		Calls, Date,	//	04/08/20
		Time,	//	10:20J
		Code, Glid,
		Hiss, Myrs, Freq, Mode,
		_Name, Qth, Rmk1, Rmk2: String;
		Qsl: array [0..3] of Char;
		Flag1: Word;
	end;

	TJccgMas = Packed record
		code: array [0..5] of Char;
		qth: array [0..33] of Char;
		flg: Char;
		hed: array [0..3] of Char;	//	Hed + Eria
		Cfm: Word;
		Wkd: Word;
		Ido: array [0..5] of Byte;
		dummy: Char;
	end;

	TThLog = Packed record
		Qso: TQsoBuff;		//	prnobt@
		logdt: TLogData;
		jccmas: TJccgMas;
		ldbf: TDBFh;
		mdbf: TDBFh;
		Ndxp: array [0..5] of TIDXh;
		flush: SmallInt;
	end;

{ ====== [U[Xgp\ ====== }
	TLogUser2 = Packed record
		fpos: array [0..2] of Char;
		calli: LongInt;
	end;

	pQsoBuff3Arry = ^TQsoBuff3Arry;
	TQsoBuff3Arry = array [0..1999999] of TQsoBuff3;

	pIntArray = ^TIntArray;
	TIntArray = array [0..1999999] of Integer;
	pWordArray = ^TWordArray;
	TWordArray = array [0..1999999] of Word;
	pBoolArray = ^TBoolArray;
	TBoolArray = array [0..1999999] of ByteBool;
	TGetDiskFreeSpEx = function(lpDirectoryName: PChar;
			var lpFreeBytesAvailableToCaller, lpTotalNumberOfBytes,
			lpTotalNumberOfFreeBytes: Comp): BOOL;	stdcall;
	TUnLha32 = function(const _hwnd: THandle; const _CmdLine: PChar;
			_Output: PChar; const _Size: Integer): Integer; stdcall;
	TAboutBoxDll = procedure(sstr: PChar);	StdCall;

{ ***** From HAMLOG50.DLL ***** }
function  GetThdllVersion:	Integer;	StdCall;
function  MakeIndex(const Dname, Key, IdxName: PChar): Integer; StdCall;
function  dbf_create(const fname: PChar; var s: TLogStruct): Integer; StdCall;
function  dbf_open(const fname: PChar; var dbf: TDBFh): Integer; StdCall;
procedure dbf_close(var dbf: TDBFh); StdCall;
function  dbf_read(var dbf: TDBFh; rno: LongInt; var buf): Integer; StdCall;
function  dbf_read2(var dbf: TDBFh; rno: Longint; var buf; cnt: Integer): Integer; StdCall;
function  dbf_rsize(var dbf: TDBFh): Integer; StdCall;
function  dbf_write(var dbf: TDBFh; rno: LongInt;
				buf: PChar): Integer; StdCall;
function  dbf_write2(var dbf: TDBFh; rno: LongInt;
				const buf: PChar; const fst, size: Integer): Integer; StdCall;
function  DB_append(var Th: TThLog; const rno: Integer): Integer; StdCall;
function  THW_skip(var Th: TThLog; const n, flg: Integer): Integer; StdCall;
function  THW_seek(var Th: TThLog; Key: PChar;
				const flg: Integer): Integer; StdCall;
function  THW_top(var Th: TThLog; const flg: Integer): Integer; StdCall;
function  THW_btm(var Th: TThLog; const flg: Integer): Integer; StdCall;
function  dbf_packwk(var dbf: TDBFh;
				buff: PChar; size: Integer): Integer; StdCall;
function  dbf_delete(var dbf: TDBFh; const rno: LongInt): Integer; StdCall;
function  THW_read(var Th: TThLog;
				const rno: Longint; const flg: Integer): Integer; StdCall;
function  THW_readv(var Th: TThLog;
				const rno: Longint; var Qso: TQsoBuff): Integer; StdCall;
function  THW_update(var Th, Th2: TThLog; const rno: Longint;
				const flg: Integer; var mes: Integer): Integer; StdCall;
function  THW_append(var Th: TThLog; const flg: Integer;
				var mes: Integer): Integer; StdCall;
procedure THW_flush(var Th: TThLog);	StdCall;
function  Idx_ReadKey(var Th: TThLog; const flg: Integer): PChar; StdCall;
function  idx_open(const fname: PChar; var idx: TIDXh): Integer;	StdCall;
procedure idx_close(var idx: TIDXh); StdCall;
function  idx_search(var idx: TIDXh; const key: PChar;
				len: Integer): LongInt; StdCall;
function  idx_next(var idx: TIDXh): LongInt; StdCall;
function  idx_back(var idx: TIDXh): LongInt; StdCall;
function  idx_top(var idx: TIDXh): LongInt; StdCall;
function  idx_bottom(var idx: TIDXh): LongInt; StdCall;
function  isPortable(const c: PChar): Integer;	StdCall;
procedure GetDxEntity(const calls: PChar; buff: PChar);	StdCall;
procedure QSL_Rcv(var Th: TThLog; const rno: Longint; const mk: Char); StdCall;
procedure QSL_Send(var Th: TThLog; const rno: Longint; const mk: Char); StdCall;
function  StrToLong(const astr: PChar): LongInt;	StdCall;
function  HamlogOpen(AboutBoxDll: TAboutBoxDll; var Th: TThLog;
		const fname: PChar; const isComp: Integer): Integer; StdCall;
procedure HamlogClose(var Th: TThLog; const isComp: Integer); StdCall;
function  THW_idxrmv(var Th: TThLog; const rno: Longint;
				const i: Integer; const key: PChar): Integer;	StdCall;
function  FreqPCheck(const freq: PChar): Integer;	StdCall;
procedure Wget_bit(wstr: PChar; var wc: TJccgMas);	StdCall;
procedure Wput_bit(var Th: TThLog; const wc: PChar);	StdCall;
function  ChosonCheck(const cd: PChar): Integer;	StdCall;
procedure WkdCfmCheck(Handle: HDC; var Th: TThLog;
			var wno: LongInt; const NoWkd: PChar; const Non: Char);	StdCall;
function  Get_lupdate(var dbf: TDBFh): PChar;	StdCall;
procedure THW_zap(var Th: TThLog);	StdCall;
function  T_Open(const fname: PChar): Integer;	StdCall;
procedure T_Puts(const buff: PChar; Handle: Integer);	StdCall;
function  T_GetDbs(var buff; slen, handle: Integer): Integer;	StdCall;
function  T_Gets(var buff; slen, handle: Integer): Integer;	StdCall;
function  JStrStr(const s1, s2: PChar): Integer;	StdCall;
function  DateComp(const d1, d2: PChar): Integer;	StdCall;
function  isExPrefix(const call1, call2, call3: PChar;
			const calls: PChar): Integer; StdCall;
function  DateTimeSort(const HdbFile: PChar): Integer;	StdCall;
function  MasterSort(var Th: TThLog): Integer;	StdCall;
function  CopyFromMAS(var Th: TThLog): Longint;	StdCall;
function  dbf_rcount(var dbf: TDBFh): LongInt;	StdCall;
function  dbf_recno(var dbf: TDBFh): LongInt;	StdCall;
procedure _Qsorter(var pData; const Cnt, size: Integer);	StdCall;
function  Han2ZenStr(const str: PChar): PChar;	StdCall;
function SetDbsShare(const i: Integer): Boolean;	StdCall;

function  DbsDbrOpen(var th: TOldLog; fname: PChar): Integer;	StdCall;
procedure DbsDbrClose(var th: TOldLog); StdCall;
function  DbsDbrRead(var th: TOldLog; rno: LongInt): Integer;	StdCall;



implementation
const	HamlogDllName = 'Hamlog50.dll';
{ ****  by  Borland C++ Ver5.0J **** }
function  GetThdllVersion;	external HamlogDllName;	//	Index 1;
function  MakeIndex;		external HamlogDllName;	//	Index 2;
function  dbf_create;		external HamlogDllName;	//	Index 3;
function  dbf_open;			external HamlogDllName;	//	Index 4;
procedure dbf_close;		external HamlogDllName;	//	Index 5;
function  dbf_read;			external HamlogDllName;	//	Index 6;
function  dbf_rsize;		external HamlogDllName;	//	Index 7;
function  dbf_write;		external HamlogDllName;	//	Index 8;
function  dbf_write2;		external HamlogDllName;	//	Index 9;
function  DB_append;		external HamlogDllName;
function  THW_read;			external HamlogDllName;	//	Index 10;
function  THW_readv;		external HamlogDllName;
function  THW_skip;			external HamlogDllName;	//	Index 11;
function  THW_seek;			external HamlogDllName;	//	Index 12;
function  THW_top;			external HamlogDllName;	//	Index 13;
function  THW_btm;			external HamlogDllName;	//	Index 14;
function  dbf_read2;		external HamlogDllName;
function  dbf_packwk;		external HamlogDllName;	//	Index 16;
function  dbf_delete;		external HamlogDllName;	//	Index 17;
function  THW_update;		external HamlogDllName;	//	Index 18;
function  THW_append;		external HamlogDllName;	//	Index 19;
procedure THW_flush;		external HamlogDllName;	//	Index 20;
function  Idx_ReadKey;		external HamlogDllName;	//	Index 21;
function  idx_open;			external HamlogDllName;	//	Index 22;
procedure idx_close;		external HamlogDllName;	//	Index 23;
function  idx_search;		external HamlogDllName;	//	Index 24;
function  idx_next;			external HamlogDllName;	//	Index 25;
function  idx_back;			external HamlogDllName;	//	Index 26;
function  idx_top;			external HamlogDllName;	//	Index 27;
function  idx_bottom;		external HamlogDllName;	//	Index 28;
procedure GetDxEntity;		external HamlogDllName;
function  isPortable;		external HamlogDllName;
procedure QSL_Rcv;			external HamlogDllName;	//	Index 30;
procedure QSL_Send;			external HamlogDllName;	//	Index 31;
function  StrToLong;		external HamlogDllName;	//	Index 32;
function  HamlogOpen;		external HamlogDllName;	//	Index 37;
procedure HamlogClose;		external HamlogDllName;	//	Index 38;
function  THW_idxrmv;       external HamlogDllName;	//	Index 39;
function  FreqPCheck;		external HamlogDllName;	//	Index 40;
procedure Wget_bit;			external HamlogDllName;	//	Index 41;
procedure Wput_bit;			external HamlogDllName;	//	Index 42;
function  ChosonCheck;		external HamlogDllName;	//	Index 43;
function  JStrStr;			external HamlogDllName;
procedure WkdCfmCheck;		external HamlogDllName;	//	Index 44;
function  Get_lupdate;		external HamlogDllName;	//	Index 45;
procedure THW_zap;			external HamlogDllName;	//	Index 46;
function  T_Open;			external HamlogDllName;	//	Index 48;
procedure T_Puts;			external HamlogDllName;	//	Index 49;
function  T_GetDbs;			external HamlogDllName;	//	Index 50;
function  T_Gets;			external HamlogDllName;	//	Index 51;
function  DateComp;			external HamlogDllName;	//	Index 53;
function  isExPrefix;       external HamlogDllName;	//	Index 54;
function  DateTimeSort;		external HamlogDllName;	//	Index 57;
function  MasterSort;		external HamlogDllName;	//	Index 58;
function  CopyFromMAS;		external HamlogDllName;	//	Index 60;
function  dbf_rcount;		external HamlogDllName;	//	Index 62;
function  dbf_recno;		external HamlogDllName;	//	Index 63;
procedure _Qsorter;			external HamlogDllName;
function  Han2ZenStr;		external HamlogDllName;
function  SetDbsShare;		external HamlogDllName;
function  DbsDbrOpen;		external HamlogDllName;
procedure DbsDbrClose;		external HamlogDllName;
function  DbsDbrRead;		external HamlogDllName;

end.

